depends 'ship_loadouts'

_ENV = _G


function redesign_ships(empire)
  local designs in empire

  --local part_info = empire : available_part_info()
  console('redesigning for empire:', empire.name, empire._recorded_name)
  --print(stack_trace(1,6))
  inc_loading_time_estimate(1.5)
  local _TRACE_INFO = empire.name
  for name, design in pairs(designs)
      
    if design.carried_design goto next_design end

    local new_design = Design.auto_design {
      ..design!.ship_drawer, 
      ..design!.config_name, 
      ..design!.design_name,
      ..design.planet_info,
      ..design.design_hint,
      ..design.loadout_hint,
      ..empire,
    }

    if not table_eq(design,new_design)
      all_designs[design._ikey] = new_design
    end

    ::next_design::
  end

end

function add_empire_design(empire, config, design_name, design_hint, loadout_hint)
  local ship_drawer, config_name in config!

  local design = Design.auto_design {
    ..ship_drawer,
    ..empire,
    ..config_name,
    ..design_name,
    ..design_hint,
    ..loadout_hint,
  }
      
  local _TRACE_TABLE = design
  local design_ref = new_design_ref(design)
  empire.designs[design_ref._ikey] = design_ref

  local carried_design_hint in config

  if carried_design_hint
    --print('doin somethin')
    local carried_config = empire : find_linked_config(config)!

    local carried_design = Design.auto_design {
      ..carried_config.ship_drawer,
      ..empire,
      ..carried_config.config_name,
      design_name = carried_design_hint,
      design_hint = carried_design_hint,
      carrying_design=design_ref,
    }
    local carried_design_ref = new_design_ref(carried_design)
    design_ref.carried_design = carried_design_ref
  end

  return { design_key = design_ref._ikey, design_name=design.design_name, ..ship_drawer }
end


function init_designs_for_config(empire,config)
  local config_name in config!

  local new_designs = {}

  local function create_and_append_design(...)
    append(add_empire_design(...), new_designs)
  end

  for hint ; subconfig_hints(config)

    print(empire.name, config_name, hint)

    if hint=='Outpost' goto next_hint end

    if hint ~= config_name
      create_and_append_design(empire, config, hint, hint) --subconfig
    else
      local theme = drawers.get_theme(config.ship_drawer)
      local ship_loadouts = loadout_hints[theme]?[config_name]

      if ship_loadouts and (active_ai(empire) or options.ai_dev)
        print(empire.name, config_name, hint, t2s | ship_loadouts)
        --if a card system was implemented, it could further restrict loadouts here.
        --for example, if the AI wanted to focus solely on long-range

        for loadout_hint ; ship_loadouts
          create_and_append_design(empire, config, config_name, config_name, loadout_hint)
        end
      else
        create_and_append_design(empire, config, config_name, config_name)
      end
    end

    ::next_hint::
  end 

  return new_designs
end

if lua_load_complete
  for i,empire ; all_empires
    if empire.name == 'Gremak'
      for i,design ; empire.designs
        print(design.design_name, design.design_hint)
      end
    end
  end
  local k,v=next(drawers.BladeDD.configs)
  print | v2s| subconfig_hints(v)
end