local patch_config = drawers.BladeCL.configs["Light Cruiser"]
for i,mount ; patch_config.available_mounts
  if mount.mlocation == 1 or mount.mlocation == 2
    mount.hints["Scout Cruiser"] = nil
  end
  if mount.mlocation == 3
    mount.hints = { ["Scout Cruiser"] = "Deep Space Scanner" }
  end
end

--[=[

_ENV = ship_drawer_env {
  --default_n=1
}

hull_class= 3
-- default_n=8

pack_w,pack_h=2,3
fleet_scale=1.09

create_config "Light Cruiser" { 
  

  
  --hull_cost_mult=4,
  --hull_point_mult=4,

  create_mounts =  {  
    Hardpoint 'Missile' {  hints = { ["Light Cruiser"] = "Viper Launcher"}}, 

    Hardpoint 'Turret' {part_id=3, firing_arc='FX' },
    Hardpoint 'Turret' {part_id=4, firing_arc='FX' },
    Hardpoint 'Turret' { 
      part_id=1,
      hints = { ["Scout Cruiser"] = "Deep Space Scanner" },
      firing_arc='LH' 
    },
    Hardpoint 'Turret' { 
      part_id=2,
      hints = { ["Scout Cruiser"] = "Deep Space Scanner" },
      firing_arc='RH' 
    },
    SystemSlot,
    SystemSlot,
    SystemSlot { hints = { ["Scout Cruiser"] = "Warp Lane Amplifier" } },
    ArmorSlot,
    --ArmorSlot { space_mult=10 }, -- huge armor slot
  }
}

--[[
create_config "Scout Cruiser" { 
  unlock = 'Scout',
  create_mounts = base_mounts {
    Built_In 'Warp Lane Amplifier' 
  },
  component_set = set 'sensor_module',
}
--]]

Turret = raw_import_align {
  -- CL only turrets
  351+1,646-10,
  1000-351-1,646-10,

  -- center turrets
  500-1,413+10,
  500-1,505+10,

  Rotations = {90+45,-45-90}
}

component_draw_function()

--components = { .. component_draw 'sensor_module' }

register_components 'sensor_module'


BladeEngine.make_requests {

  w=100,

  [1] = { x=421, y=1000-804},
  [2] = { x=1000-423, y=1000-804},

}
--]=]